static const char *RcsCH4     = "";
static const char *TagName   = "";
static const char *HttpServer= "";
//+=============================================================================
//
// file :        AH401BClass.cpp
//
// description : C++ source for the AH401BClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the AH401B once per process.
//
// project :     TANGO Device Server
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza (TS)
//              ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF 
//=============================================================================


#include <tango.h>

#include <AH401B.h>
#include <AH401BClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create AH401BClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AH401B_class(const char *name) {
		return AH401B_ns::AH401BClass::init(name);
	}
}


namespace AH401B_ns
{
//+----------------------------------------------------------------------------
//
// method : 		ResetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ResetClass::execute(): arrived" << endl;

	((static_cast<AH401B *>(device))->reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AcquireBackgroundClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AcquireBackgroundClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AcquireBackgroundClass::execute(): arrived" << endl;

	Tango::DevLong	argin;
	extract(in_any, argin);

	((static_cast<AH401B *>(device))->acquire_background(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH4DataCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH4DataCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH4DataCmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch4_data(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH3DataCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH3DataCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH3DataCmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch3_data(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH2DataCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH2DataCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH2DataCmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch2_data(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH1DataClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH1DataClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH1DataClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch1_data(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH4Cmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH4Cmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH4Cmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch4(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH3Cmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH3Cmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH3Cmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch3(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH2Cmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH2Cmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH2Cmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch2(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetCH1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCH1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCH1Class::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_ch1(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		StartCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartCmd::execute(): arrived" << endl;

	((static_cast<AH401B *>(device))->start());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StopCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StopCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StopCmd::execute(): arrived" << endl;

	((static_cast<AH401B *>(device))->stop());
	return new CORBA::Any();
}



//+----------------------------------------------------------------------------
//
// method : 		GetSamplesCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetSamplesCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetSamplesCmd::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->get_samples(argin));
}


//+----------------------------------------------------------------------------
//
// method : 		GetSnapshotCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetSnapshotCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetSnapshotCmd::execute(): arrived" << endl;

	return insert((static_cast<AH401B *>(device))->get_snapshot());
}


//+----------------------------------------------------------------------------
//
// method : 		SendCommandCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SendCommandCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SendCommandCmd::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	return insert((static_cast<AH401B *>(device))->send_command(argin));
}






//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
AH401BClass *AH401BClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::AH401BClass(string &s)
// 
// description : 	constructor for the AH401BClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
AH401BClass::AH401BClass(string &s):DeviceClass(s)
{

	cout2 << "Entering AH401BClass constructor" << endl;
	set_default_property();
	write_class_property();
	get_class_property();
	
	cout2 << "Leaving AH401BClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::~AH401BClass()
// 
// description : 	destructor for the AH401BClass
//
//-----------------------------------------------------------------------------
AH401BClass::~AH401BClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
AH401BClass *AH401BClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AH401BClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

AH401BClass *AH401BClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void AH401BClass::command_factory()
{
	command_list.push_back(new SendCommandCmd("SendCommand",
		Tango::DEV_STRING, Tango::DEV_STRING,
		"Command string",
		"Reply",
		Tango::OPERATOR));
	/*command_list.push_back(new GetSnapshotCmd("GetSnapshot",
		Tango::DEV_VOID, Tango::DEVVAR_LONGARRAY,
		"",
		"The array with the 4 current measurements",
		Tango::OPERATOR));
	command_list.push_back(new GetSamplesCmd("GetSamples",
		Tango::DEV_USHORT, Tango::DEVVAR_ULONGARRAY,
		"Fake. Use 1 and get all 4 channels",
		"Array of samples",
		Tango::OPERATOR));*/
	command_list.push_back(new StartCmd("Start",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StopCmd("Stop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH1DataClass("GetCH1Data",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH2DataCmd("GetCH2Data",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH3DataCmd("GetCH3Data",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH4DataCmd("GetCH4Data",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH1Class("GetCH1",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH2Cmd("GetCH2",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH3Cmd("GetCH3",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCH4Cmd("GetCH4",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AcquireBackgroundClass("AcquireBackground",
		Tango::DEV_LONG, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ResetClass("Reset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum AH401BClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum AH401BClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum AH401BClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void AH401BClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new AH401B(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: AH401BClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void AH401BClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : CH1Data
	CH1DataAttrib	*ch1_data = new CH1DataAttrib();
	att_list.push_back(ch1_data);

	//	Attribute : CH2Data
	CH2DataAttrib	*ch2_data = new CH2DataAttrib();
	att_list.push_back(ch2_data);

	//	Attribute : CH3Data
	CH3DataAttrib	*ch3_data = new CH3DataAttrib();
	att_list.push_back(ch3_data);

	//	Attribute : CH4Data
	CH4DataAttrib	*ch4_data = new CH4DataAttrib();
	att_list.push_back(ch4_data);

	//	Attribute : CH1
	CH1Attrib	*ch1 = new CH1Attrib();
	Tango::UserDefaultAttrProp	ch1_prop;
	ch1_prop.set_unit("pC");
	ch1_prop.set_standard_unit("1");
	ch1_prop.set_display_unit("pC");
	ch1_prop.set_format("%9.5f");
	ch1->set_default_properties(ch1_prop);
	att_list.push_back(ch1);

	//	Attribute : CH2
	CH2Attrib	*ch2 = new CH2Attrib();
	Tango::UserDefaultAttrProp	ch2_prop;
	ch2_prop.set_unit("pC");
	ch2_prop.set_standard_unit("1");
	ch2_prop.set_display_unit("pC");
	ch2_prop.set_format("%9.5f");
	ch2->set_default_properties(ch2_prop);
	att_list.push_back(ch2);

	//	Attribute : CH3
	CH3Attrib	*ch3 = new CH3Attrib();
	Tango::UserDefaultAttrProp	ch3_prop;
	ch3_prop.set_unit("pC");
	ch3_prop.set_standard_unit("1");
	ch3_prop.set_display_unit("pC");
	ch3_prop.set_format("%9.5f");
	ch3->set_default_properties(ch3_prop);
	att_list.push_back(ch3);

	//	Attribute : CH4
	CH4Attrib	*ch4 = new CH4Attrib();
	Tango::UserDefaultAttrProp	ch4_prop;
	ch4_prop.set_unit("pC");
	ch4_prop.set_standard_unit("1");
	ch4_prop.set_display_unit("pC");
	ch4_prop.set_format("%9.5f");
	ch4->set_default_properties(ch4_prop);
	att_list.push_back(ch4);

	//	Attribute : CH1Offset
	CH1OffsetAttrib	*ch1_offset = new CH1OffsetAttrib();
	Tango::UserDefaultAttrProp ch1_offset_prop;
	ch1_offset_prop.set_format("%9.5f");
	ch1_offset_prop.set_max_value("4000");
	ch1_offset_prop.set_min_value("-4000");
	ch1_offset->set_default_properties(ch1_offset_prop);
//	ch1_offset->set_memorized();
//	ch1_offset->set_memorized_init(true);
	att_list.push_back(ch1_offset);

	//	Attribute : CH2Offset
	CH2OffsetAttrib	*ch2_offset = new CH2OffsetAttrib();
	Tango::UserDefaultAttrProp ch2_offset_prop;
	ch2_offset_prop.set_format("%9.5f");
	ch2_offset_prop.set_max_value("4000");
	ch2_offset_prop.set_min_value("-4000");
	ch2_offset->set_default_properties(ch2_offset_prop);
//	ch2_offset->set_memorized();
//	ch2_offset->set_memorized_init(true);
	att_list.push_back(ch2_offset);

	//	Attribute : CH3Offset
	CH3OffsetAttrib	*ch3_offset = new CH3OffsetAttrib();
	Tango::UserDefaultAttrProp ch3_offset_prop;
	ch3_offset_prop.set_format("%9.5f");
	ch3_offset_prop.set_max_value("4000");
	ch3_offset_prop.set_min_value("-4000");
	ch3_offset->set_default_properties(ch3_offset_prop);
//	ch3_offset->set_memorized();
//	ch3_offset->set_memorized_init(true);
	att_list.push_back(ch3_offset);

	//	Attribute : CH4Offset
	CH4OffsetAttrib	*ch4_offset = new CH4OffsetAttrib();
	Tango::UserDefaultAttrProp ch4_offset_prop;
	ch4_offset_prop.set_format("%9.5f");
	ch4_offset_prop.set_max_value("4000");
	ch4_offset_prop.set_min_value("-4000");
	ch4_offset->set_default_properties(ch4_offset_prop);
//	ch4_offset->set_memorized();
//	ch4_offset->set_memorized_init(true);
	att_list.push_back(ch4_offset);

	//	Attribute : Alarm1
	Alarm1Attrib	*alarm1 = new Alarm1Attrib();
	Tango::UserDefaultAttrProp alarm1_prop;
	alarm1_prop.set_format("%7d");
	//alarm1_prop.set_max_value("9999999");
	alarm1_prop.set_min_value("-1");
	alarm1->set_default_properties(alarm1_prop);
	alarm1->set_memorized();
	alarm1->set_memorized_init(true);
	att_list.push_back(alarm1);
	
	//	Attribute : Alarm2
	Alarm2Attrib	*alarm2 = new Alarm2Attrib();
	Tango::UserDefaultAttrProp alarm2_prop;
	alarm2_prop.set_format("%7d");
	//alarm2_prop.set_max_value("9999999");
	alarm2_prop.set_min_value("-1");
	alarm2->set_default_properties(alarm2_prop);
	alarm2->set_memorized();
	alarm2->set_memorized_init(true);
	att_list.push_back(alarm2);

	//	Attribute : IntegrationTime
	IntegrationTimeAttrib	*integration_time = new IntegrationTimeAttrib();
	Tango::UserDefaultAttrProp	integration_time_prop;
	integration_time_prop.set_unit("ms");
	integration_time_prop.set_standard_unit("1");
	integration_time_prop.set_display_unit("ms");
	integration_time_prop.set_format("%5.1f");
	integration_time_prop.set_max_value("1000");
	integration_time_prop.set_min_value("1");
	integration_time->set_default_properties(integration_time_prop);
	integration_time->set_memorized();
	integration_time->set_memorized_init(true);
	att_list.push_back(integration_time);

	//	Attribute : Range
	RangeAttrib	*range = new RangeAttrib();
	Tango::UserDefaultAttrProp	range_prop;
	range_prop.set_format("%d");
	range_prop.set_max_value("7");
	range_prop.set_min_value("0");
	range->set_default_properties(range_prop);
	range->set_memorized();
	range->set_memorized_init(true);
	att_list.push_back(range);

	//	Attribute : NumAcq
	NumAcqAttrib	*num_acq = new NumAcqAttrib();
	Tango::UserDefaultAttrProp	num_acq_prop;
	num_acq_prop.set_format("%d");
	num_acq_prop.set_max_value("100");
	num_acq_prop.set_min_value("0");
	num_acq_prop.set_description("Numbero of acquisitions per trigger");
	num_acq->set_default_properties(num_acq_prop);
	att_list.push_back(num_acq);

	//	Attribute : Background
	BackgroundAttrib	*background = new BackgroundAttrib();
	Tango::UserDefaultAttrProp	background_prop;
	background_prop.set_description("Enable/disable background subtraction");
	background->set_default_properties(background_prop);
	background->set_memorized();
	background->set_memorized_init(true);
	att_list.push_back(background);

	//	Attribute : Calibration
	CalibrationAttrib	*calibration = new CalibrationAttrib();
	Tango::UserDefaultAttrProp	calibration_prop;
	calibration_prop.set_description("Enable/disable calibration");
	calibration->set_default_properties(calibration_prop);
	calibration->set_memorized();
	calibration->set_memorized_init(true);
	att_list.push_back(calibration);

	//	Attribute : BunchNumber
	BunchNumberAttrib	*bunch_number = new BunchNumberAttrib();
	att_list.push_back(bunch_number);

	//	Attribute : PAStatus
	PAStatusAttrib	*pastatus = new PAStatusAttrib();
	Tango::UserDefaultAttrProp	pastatus_prop;
	pastatus_prop.set_description("ACQ 0\nBDR 1\nBIN 2\nHLF 3\nITM 4\nRNG 5\nTRG 6");
	pastatus->set_default_properties(pastatus_prop);
	att_list.push_back(pastatus);
	
	//	Attribute : HighVoltage
	HighVoltageAttrib	*high_voltage = new HighVoltageAttrib();
	Tango::UserDefaultAttrProp	high_voltage_prop;
	high_voltage_prop.set_unit("V");
	high_voltage_prop.set_standard_unit("1");
	high_voltage_prop.set_display_unit("V");
	high_voltage_prop.set_format("%6.2f");
	high_voltage_prop.set_max_value("1000");
	high_voltage_prop.set_min_value("0");
	high_voltage_prop.set_description("High Voltage");
	high_voltage->set_default_properties(high_voltage_prop);
	high_voltage->set_memorized();
	high_voltage->set_memorized_init(true);
	att_list.push_back(high_voltage);

	//	Attribute : HighVoltageSet
	HighVoltageSetAttrib	*high_voltage_set = new HighVoltageSetAttrib();
	Tango::UserDefaultAttrProp	high_voltage_set_prop;
	high_voltage_set_prop.set_unit("V");
	high_voltage_set_prop.set_standard_unit("1");
	high_voltage_set_prop.set_display_unit("V");
	high_voltage_set_prop.set_format("%6.2f");
	high_voltage_set_prop.set_max_value("1000");
	high_voltage_set_prop.set_min_value("0");
	high_voltage_set_prop.set_description("High Voltage");
	high_voltage_set->set_default_properties(high_voltage_set_prop);
	att_list.push_back(high_voltage_set);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}


//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void AH401BClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	//int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	AH401BClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void AH401BClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "BufferCH1Device";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BufferCH2Device";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BufferCH3Device";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BufferCH4Device";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CH1Cal";
	prop_desc = "Calibration array (proportional value) for each range value [0..7]\nEx:\n1.0:2.0:3.0:4.0:5.0:6.0:7.0:8.0";
	prop_def  = "1:1:1:1:1:1:1:1";
	vect_data.clear();
	vect_data.push_back("1:1:1:1:1:1:1:1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CH2Cal";
	prop_desc = "";
	prop_def  = "1:1:1:1:1:1:1:1";
	vect_data.clear();
	vect_data.push_back("1:1:1:1:1:1:1:1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CH3Cal";
	prop_desc = "";
	prop_def  = "1:1:1:1:1:1:1:1";
	vect_data.clear();
	vect_data.push_back("1:1:1:1:1:1:1:1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CH4Cal";
	prop_desc = "";
	prop_def  = "1:1:1:1:1:1:1:1";
	vect_data.clear();
	vect_data.push_back("1:1:1:1:1:1:1:1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "IntegrationTime";
	prop_desc = "";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "IpAddress";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "NSamples";
	prop_desc = "Number of samples to keep in memory, in order to retrieve with getSamples command.";
	prop_def  = "500";
	vect_data.clear();
	vect_data.push_back("500");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "NumAcq";
	prop_desc = "Number of acquisitions per trigger";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Range";
	prop_desc = "";
	prop_def  = "7";
	vect_data.clear();
	vect_data.push_back("7");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BackgroundLevel";
	prop_desc = "Backgroud level\nch1:ch2:ch3:ch4";
	prop_def  = "0:0:0:0";
	vect_data.clear();
	vect_data.push_back("0:0:0:0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PicoammeterIndex";
	prop_desc = "Picoammeter index for the RT module";
	prop_def  = "";
	vect_data.clear();
	vect_data.push_back("");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RnmIndex";
	prop_desc = "Index in rnm for the RT module";
	prop_def  = "";
	vect_data.clear();
	vect_data.push_back("");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PicoammeterIP";
	prop_desc = "IP address of Picoammeter";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PicoammeterMAC";
	prop_desc = "MAC address of Picoammeter";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PicoammeterPort";
	prop_desc = "UDP port of Picoammeter";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CpuIP";
	prop_desc = "IP address of CPU";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CpuPort";
	prop_desc = "UDP port of CPU";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Triggered";
	prop_desc = "If not triggered TRG OFF, ACQ ON and NAQ 0, else TRG ON, ACQ OFF, NAQ 1";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "HalfMode";
	prop_desc = "If HalfMode HLF ON (only one integrator circuit running, half speed, bet noise) else HLF OFF (two integrator circuits)";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "XpiMode";
	prop_desc = "Use Xpi commands";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		AH401BClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void AH401BClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("AH401B TANGO DS");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("TANGO server interfacing ELETTRA AH401B picoammeter");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsCH4(RcsCH4);
	string	filename(classname);
	start = rcsCH4.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsCH4.find(filename);
		if (end>start)
		{
			string	strloc = rcsCH4.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	cout << "going to get_db_class()->put_property(data)" << endl;
	try {
	get_db_class()->put_property(data);
	} catch(Tango::DevFailed &e)
	{
		cout<<"failed get_db_class()->put_property(data);, err="<<e.errors[0].desc<<endl;
	}
	cout << "executed get_db_class()->put_property(data)" << endl;
}

}	// namespace
