//=============================================================================
//
// file :         AH401BClass.h
//
// description :  Include for the AH401BClass root class.
//                This class is represents the singleton class for
//                the AH401B device class.
//                It contains all properties and methods which the 
//                AH401B requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza (TS)
//              ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF 
//=============================================================================

#ifndef _AH401BCLASS_H
#define _AH401BCLASS_H

#include <tango.h>
#include <AH401B.h>


namespace AH401B_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class Alarm2Attrib: public Tango::Attr
{
public:
	Alarm2Attrib():Attr("Alarm2", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Alarm2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_Alarm2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_Alarm2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_Alarm2_allowed(ty);}
};

class Alarm1Attrib: public Tango::Attr
{
public:
	Alarm1Attrib():Attr("Alarm1", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Alarm1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_Alarm1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_Alarm1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_Alarm1_allowed(ty);}
};

class CH1OffsetAttrib: public Tango::Attr
{
public:
	CH1OffsetAttrib():Attr("CH1Offset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CH1OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH1Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_CH1Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH1Offset_allowed(ty);}
};

class CH2OffsetAttrib: public Tango::Attr
{
public:
	CH2OffsetAttrib():Attr("CH2Offset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CH2OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH2Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_CH2Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH2Offset_allowed(ty);}
};

class CH3OffsetAttrib: public Tango::Attr
{
public:
	CH3OffsetAttrib():Attr("CH3Offset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CH3OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH3Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_CH3Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH3Offset_allowed(ty);}
};

class CH4OffsetAttrib: public Tango::Attr
{
public:
	CH4OffsetAttrib():Attr("CH4Offset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CH4OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH4Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_CH4Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH4Offset_allowed(ty);}
};

class HighVoltageAttrib: public Tango::Attr
{
public:
	HighVoltageAttrib():Attr("HighVoltage", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~HighVoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_HighVoltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_HighVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_HighVoltage_allowed(ty);}
};

class HighVoltageSetAttrib: public Tango::Attr
{
public:
	HighVoltageSetAttrib():Attr("HighVoltageSet", Tango::DEV_DOUBLE, Tango::READ) {};
	~HighVoltageSetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_HighVoltageSet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_HighVoltageSet_allowed(ty);}
};

class PAStatusAttrib: public Tango::SpectrumAttr
{
public:
	PAStatusAttrib():SpectrumAttr("PAStatus", Tango::DEV_LONG, Tango::READ, 8) {};
	~PAStatusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_PAStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_PAStatus_allowed(ty);}
};

class BunchNumberAttrib: public Tango::Attr
{
public:
	BunchNumberAttrib():Attr("BunchNumber", Tango::DEV_LONG, Tango::READ) {};
	~BunchNumberAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_BunchNumber(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_BunchNumber_allowed(ty);}
};

class CalibrationAttrib: public Tango::Attr
{
public:
	CalibrationAttrib():Attr("Calibration", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~CalibrationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_Calibration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_Calibration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_Calibration_allowed(ty);}
};

class BackgroundAttrib: public Tango::Attr
{
public:
	BackgroundAttrib():Attr("Background", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~BackgroundAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_Background(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_Background(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_Background_allowed(ty);}
};

class NumAcqAttrib: public Tango::Attr
{
public:
	NumAcqAttrib():Attr("NumAcq", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~NumAcqAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_NumAcq(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_NumAcq(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_NumAcq_allowed(ty);}
};

class RangeAttrib: public Tango::Attr
{
public:
	RangeAttrib():Attr("Range", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~RangeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_Range(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_Range(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_Range_allowed(ty);}
};

class IntegrationTimeAttrib: public Tango::Attr
{
public:
	IntegrationTimeAttrib():Attr("IntegrationTime", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~IntegrationTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_IntegrationTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<AH401B *>(dev))->write_IntegrationTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_IntegrationTime_allowed(ty);}
};

class CH4Attrib: public Tango::Attr
{
public:
	CH4Attrib():Attr("CH4", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH4_allowed(ty);}
};

class CH3Attrib: public Tango::Attr
{
public:
	CH3Attrib():Attr("CH3", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH3_allowed(ty);}
};

class CH2Attrib: public Tango::Attr
{
public:
	CH2Attrib():Attr("CH2", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH2_allowed(ty);}
};

class CH1Attrib: public Tango::Attr
{
public:
	CH1Attrib():Attr("CH1", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH1_allowed(ty);}
};

class CH4DataAttrib: public Tango::Attr
{
public:
	CH4DataAttrib():Attr("CH4Data", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH4DataAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH4Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH4Data_allowed(ty);}
};

class CH3DataAttrib: public Tango::Attr
{
public:
	CH3DataAttrib():Attr("CH3Data", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH3DataAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH3Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH3Data_allowed(ty);}
};

class CH2DataAttrib: public Tango::Attr
{
public:
	CH2DataAttrib():Attr("CH2Data", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH2DataAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH2Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH2Data_allowed(ty);}
};

class CH1DataAttrib: public Tango::Attr
{
public:
	CH1DataAttrib():Attr("CH1Data", Tango::DEV_DOUBLE, Tango::READ) {};
	~CH1DataAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<AH401B *>(dev))->read_CH1Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<AH401B *>(dev))->is_CH1Data_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_Reset_allowed(any);}
};

class AcquireBackgroundClass : public Tango::Command
{
public:
	AcquireBackgroundClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AcquireBackgroundClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AcquireBackgroundClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_AcquireBackground_allowed(any);}
};



class GetCH4DataCmd : public Tango::Command
{
public:
	GetCH4DataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH4DataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH4DataCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH4Data_allowed(any);}
};



class GetCH3DataCmd : public Tango::Command
{
public:
	GetCH3DataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH3DataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH3DataCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH3Data_allowed(any);}
};



class GetCH2DataCmd : public Tango::Command
{
public:
	GetCH2DataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH2DataCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH2DataCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH2Data_allowed(any);}
};



class GetCH1DataClass : public Tango::Command
{
public:
	GetCH1DataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH1DataClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH1DataClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH1Data_allowed(any);}
};


class GetCH4Cmd : public Tango::Command
{
public:
	GetCH4Cmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH4Cmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH4Cmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH4_allowed(any);}
};



class GetCH3Cmd : public Tango::Command
{
public:
	GetCH3Cmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH3Cmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH3Cmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH3_allowed(any);}
};



class GetCH2Cmd : public Tango::Command
{
public:
	GetCH2Cmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH2Cmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH2Cmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH2_allowed(any);}
};



class GetCH1Class : public Tango::Command
{
public:
	GetCH1Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetCH1Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetCH1Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetCH1_allowed(any);}
};


class StartCmd : public Tango::Command
{
public:
	StartCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_Start_allowed(any);}
};



class StopCmd : public Tango::Command
{
public:
	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_Stop_allowed(any);}
};



class GetSamplesCmd : public Tango::Command
{
public:
	GetSamplesCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetSamplesCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetSamplesCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetSamples_allowed(any);}
};



class GetSnapshotCmd : public Tango::Command
{
public:
	GetSnapshotCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetSnapshotCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetSnapshotCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_GetSnapshot_allowed(any);}
};



class SendCommandCmd : public Tango::Command
{
public:
	SendCommandCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SendCommandCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SendCommandCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH401B *>(dev))->is_SendCommand_allowed(any);}
};



//
// The AH401BClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	AH401BClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static AH401BClass *init(const char *);
	static AH401BClass *instance();
	~AH401BClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	AH401BClass(string &);
	static AH401BClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace AH401B_ns

#endif // _AH401BCLASS_H
